/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.decoder;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.minimips.op.cop0;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderCop0} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderCop0 extends DecoderItem {
  private static DecoderCop0 instance = null;

  public static DecoderCop0 get() {
    if (null == instance) {
      instance = new DecoderCop0();
    }
    return instance;
  }

  private DecoderCop0() {
    super(
        32,
        true,
        "01000000001000000000000000000000",
        "11111111111000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate cop_fun = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000000001", 2, 11))) {
      return null;
    }

    cop_fun = readNextImmediate(image, Type.CARD(21));

    return newResult(new cop0(cop_fun));
  }
}
